<?php
/*
	Wer ist Online... und ähnliches!
	Autor: syp41k
	Funktionen
*/
if(!defined('USERS-MOD')) die('#1');
# Parser Funktion
function InfoQuery($url) {
	$context = stream_context_create(array('http' => array('method' => "GET", 'header' => "Content-Type: text/xml",'timeout' => 8)));
	$file = file_get_contents($url, false, $context);
	if ($file) {
		if (strpos('200', $http_response_header[0]) || !$file) {
			return false;
		}
		$response = xmlrpc_decode($file, "utf8");
		if ($response && xmlrpc_is_fault($response)) {
			return false;
		}
		return $response;
	} else {
		return false;
	}
}

# Info Aktualisieren
function CheckAndUpdateUser() {
	global $uid, $u_db, $config, $time;
	if ($uid) {
		$q_user = $u_db->prepare("SELECT id, uid, info, time FROM `users` WHERE uid = :uid ");
		$q_user->execute(array('uid' => $uid));
		$res = $q_user->fetchAll();
		$n_user = count($res);
		if ($n_user) {
			$u_info[$res[0]['uid']] = unserialize($res[0]['info']);
			if ($time > ($res[0]['time'] + (60*60*24*intval($config['update_uinfo'])))) {
				$u_info = InfoQuery($config['site'].'/api/index/8-'.$uid);
				$q_user = $u_db->prepare("UPDATE users SET id = NULL, info = :info , time = :time WHERE uid = :uid ");
				$a_uid = array('uid' => $uid, 'info' => serialize($u_info), 'time' => $time);
				$q_user->execute($a_uid);
				$u_info[$uid] = $u_info;
			} else {
				$q_user = $u_db->prepare("UPDATE users SET time = :time WHERE uid = :uid ");
				$a_uid = array('uid' => $uid, 'time' => $time);
				$q_user->execute($a_uid);
			}
		} else {
			$u_info = InfoQuery($config['site'].'/api/index/8-'.$uid);
			$q_user = $u_db->prepare("INSERT INTO users (id, uid, info, time) VALUES(NULL, ?, ?, ?)");
			$a_uid = array($uid, serialize($u_info), $time);
			$q_user->execute($a_uid);
			$u_info[$uid] = $u_info;
		}
		return $u_info;
	} else {
		return false;
	}
}
?>